#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os
import sys

import codecs
# import urllib2
# import re

from bs4 import BeautifulSoup as Soup

def k2p_convert(fin, fout):
    if fin and fout:
        if os.path.exists(fin):
            with codecs.open(fin, 'r', encoding='utf8') as f:
                soup = Soup(f, ["lxml", "xml"])

                points_group = []

                for polygon in soup.find_all('Polygon'):
                    points = []
                    for node in polygon.find_all('coordinates'):
                       for coord in node.string.split():
                           point = coord.split(',')
                           points.append(point)
                       pass
                    points_group.append(points)


                with codecs.open(fout, 'w', encoding='utf8') as f:
                    lines = []

                    title = os.path.splitext(os.path.basename(fout))[0]
                    lines.append(title)

                    count = 0
                    for points in points_group:
                        count += 1
                        lines.append('%d' % (count))
                        for point in points:
                            line = format('   %e   %e' % (float(point[0]), float(point[1]))).upper()
                            lines.append(line)
                        lines.append('END')
                    lines.append('END')

                    f.write(os.linesep.join(lines))
            pass
        pass
    pass


if __name__ == "__main__":
    argc = len(sys.argv)-1
    if argc == 1:
        fin = sys.argv[1]
        fn = os.path.splitext(fin)[0]
        k2p_convert(fn+'.kml', fn+'.poly')
    elif argc == 2:
        fin = sys.argv[1]
        fout = sys.argv[2]
        k2p_convert(fin, fout)
    else:
        print('Usage: %s kml_file [polygon_file]' % (__file__))


